#------------------------------------------------------------------------------------------------
# Permission to use, copy, modify, and distribute this software for 
# any purpose and without fee is hereby granted.
#
# THIS SOFTWARE IS PROVIDED "AS IS" AND WITHOUT ANY EXPRESS OR
# IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED
# WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
#------------------------------------------------------------------------------------------------
#    Name:	BB_Intersect
#      By:	sdmitch
#   Usage:	Intersects the Bounding Box of a group or component with a face
#	 Note:	
#			
#    Date:	Aug 2011
#------------------------------------------------------------------------------------------------
#
require 'Sketchup'
#
if not file_loaded?("BB_Intersect.rb")
	UI.menu("plugins").add_item("BBI") {BBI.main }
end
file_loaded("BB_Intersect.rb")

module BBI

	def BBI.main
		model = Sketchup.active_model
		ent = model.entities
		sel = model.selection
		face=nil;corg=nil
		sel.each{|e|
			face=e if e.is_a?(Sketchup::Face)
			corg=e if(e.is_a?(Sketchup::Group) || e.is_a?(Sketchup::ComponentInstance))
			}
		if face && corg then
			model.start_operation	"Bounding Box Intersection"
			@bbox=ent.add_group; @bbxe=@bbox.entities; 
			BBI.make_bbox(corg)
			fgrp = ent.add_group(face); fent=fgrp.entities; # face
			igrp = ent.add_group;ient=igrp.entities; # intersection
			ftr=fgrp.transformation; itr=igrp.transformation
			fent.intersect_with(true, ftr, ient, itr, false, @bbox)
			@bbox.erase!; fgrp.explode
			model.commit_operation
		else
			UI.messagebox "Select Face and Component/Group First"
		end
	end

	def BBI.make_bbox(gorc)
		model = Sketchup.active_model
		ent = model.entities
		sel = model.selection
		p0=gorc.bounds.corner(0);p1=gorc.bounds.corner(1)
		p2=gorc.bounds.corner(2);p3=gorc.bounds.corner(3)
		p4=gorc.bounds.corner(4);p5=gorc.bounds.corner(5)
		p6=gorc.bounds.corner(6);p7=gorc.bounds.corner(7)
		@bbxe.add_face(p0,p4,p5,p1); #front
		@bbxe.add_face(p0,p2,p3,p1); #bottom
		@bbxe.add_face(p0,p2,p6,p4); #left side
		@bbxe.add_face(p4,p6,p7,p5); #top
		@bbxe.add_face(p5,p7,p3,p1); #right side
		@bbxe.add_face(p2,p6,p7,p3); #back
	end
end